## why3 0.87.0

=== examples/use_api/runstrat/Makefile ===

BINDIR=/usr/local/bin

OCAMLFIND = ocamlfind

OCAMLFIND_OPT = $(addprefix -package ,$(PACKAGES)) -annot
OCAMLOPT = $(OCAMLFIND) ocamlopt $(OCAMLFIND_OPT)
OCAMLC = $(OCAMLFIND) ocamlc $(OCAMLFIND_OPT)
OCAMLDEP = $(OCAMLFIND) ocamldep $(OCAMLFIND_OPT)

PACKAGES = unix str

all:makejob runstrat
opt: makejob.opt runstrat.opt
byte: makejob.byte runstrat.byte

printconf:
	echo $(OCAMLPATH)
	ocamlfind printconf

makeproto.cmo: makeproto.cmi
makeproto.cmx: makeproto.cmi

makejob.opt: makeproto.cmx makejob.ml
makejob.byte: makeproto.cmo makejob.ml

makejob: makejob.opt
	@rm -f makejob
	ln -s makejob.opt makejob

runstrat.opt runstrat.byte: PACKAGES += why3
runstrat.opt: makeproto.cmx runstrat.ml
runstrat.byte: makeproto.cmo runstrat.ml

runstrat: runstrat.opt
	@rm -f runstrat
	ln -s runstrat.opt runstrat

install:
	mkdir -p $(BINDIR)
	cp runstrat.opt $(BINDIR)/runstrat
	cp makejob.opt $(BINDIR)/makejob

clean:
	rm -f *.cmo *.cma *.cmx *.cmi *.o *.annot *.opt
	rm -f runstrat makejob

### Tests ###

.PHONY: test_makejob %.test_makejob_aux

TEST_MAKEJOB=$(addsuffix .test_makejob_aux , $(shell seq 5 -1 1))

test_makejob: $(TEST_MAKEJOB)
	@echo Done $(TEST_MAKEJOB)

%.test_makejob_aux: makejob
	@echo Run $*
	+./run_wait.ml e 10 ./echo_wait.ml $*
	@echo Done $*


################
# generic rules
################

%.cmi: %.mli
	$(if $(QUIET),@echo 'Ocamlc   $<' &&) $(OCAMLC) -c $<

%.cmo: %.ml
	$(if $(QUIET),@echo 'Ocamlc   $<' &&) $(OCAMLC) -c $<

%.cmx: %.ml
	$(if $(QUIET),@echo 'Ocamlopt $<' &&) $(OCAMLOPT) -c $<

%.dep: %.ml
	$(if $(QUIET),@echo 'Ocamldep $<' &&) $(OCAMLDEP) $(DEPFLAGS) $< $<i > $@

%.opt:
	$(if $(QUIET),@echo 'Ocamlopt $<' &&) $(OCAMLOPT) -linkpkg -o $@ $^

%.byte:
	$(if $(QUIET),@echo 'Ocamlc   $<' &&) $(OCAMLC) -linkpkg -o $@ $^

## why3 0.87.1

=== debian/changelog ===
why3 (0.87.1-2build1) yakkety; urgency=medium

  * No-change rebuild for ocaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 02 Sep 2016 12:11:03 +0000

why3 (0.87.1-2) unstable; urgency=medium

  * amended patch drop-timestamp: drop setting of BUILDDATE from configure.in
    (closes: #831664). Invoke autoconf, and build-depend on autoconf,
    since we patch configure.in

 -- Ralf Treinen <treinen@debian.org>  Tue, 19 Jul 2016 19:05:11 +0200

why3 (0.87.1-1) unstable; urgency=medium

  * new upstream version
    -dropped patch makefile-for-bytecode, since integrated by upstream
  * added z3 prover:
    - alternative dependency z3
    - add package test with z3
  * new patch drop-timestamp: do not include the build-timestamp in the
    produced binaries.

 -- Ralf Treinen <treinen@debian.org>  Wed, 08 Jun 2016 20:42:36 +0200

why3 (0.87.0-3) unstable; urgency=medium

  * debian/tests/*: run "why3 config --detect-provers" to make tests
    work in a clean environment.

 -- Ralf Treinen <treinen@debian.org>  Thu, 14 Apr 2016 19:00:49 +0200

why3 (0.87.0-2) unstable; urgency=medium

  * added a new binary package libwhy3-ocaml-dev
    - install libraries in install-arch target of d/rules
    - add d/*.install and d/*.dir files for this package
    - call dh_ocaml with --nodefined-map=why3-coq:Why3 since this unit is
      also exported by the library package
  * d/rules: split into -arch and -indep rules
  * d/control: split off Build-Depends-Indep
  * build and install why tactic for coq:
    - add build-dependency on libcoq-ocaml-dev
    - add coq-tactic to d/why3-coq.install
    - why3-coq: add dependencies ${ocaml:Depends} ${shlibs:Depends}
  * build with menhirlib:
    - add build-dependency on libmenhir-ocaml-dev
    - call dh_ocaml with --nodefined-map=why3-coq:MenhirLib
  * build with ocamlgraph:
    - turn build-conflict with libocamlgraph-ocaml-dev into build-dependency
    - call dh_ocaml with --nodefined-map=why3:Graph since this unit is
      also exported by libocamlgraph-ocaml-dev.
  * build with compression library:
    - added build-dependency on libzip-ocaml-dev
    - call dh_ocaml with --nodefined-map=why3-coq:Gzip,Zlib since these units
      are also exported by libzip-ocaml
  * build-dependency ocaml-nox: needs version >=3.11.2, according to
    upstream instructions.
  * added build-dependency libzarith-ocaml-dev
  * added recommendation (alternative): spass
  * added as-installed package tests:
    - why3+alt-ergo
    - why3+cvc3
    - why3+spass
  * update Vcs-* fields
  * standards-version 3.9.8 (no change)
  * patch typos: various typos found by lintian 

 -- Ralf Treinen <treinen@debian.org>  Wed, 13 Apr 2016 20:48:54 +0200

why3 (0.87.0-1) unstable; urgency=low

  * Initial Release (closes: #797696)

 -- Ralf Treinen <treinen@debian.org>  Sun, 20 Mar 2016 18:44:54 +0100

=== debian/control ===
Source: why3
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Build-Depends:
  autoconf, 
# autoconf only as long as we patch configure.in
  debhelper (>= 9), dh-ocaml,
  ocaml-nox (>= 3.11.2),
  menhir, libmenhir-ocaml-dev,
  libzarith-ocaml-dev,
  liblablgtk2-ocaml-dev, liblablgtksourceview2-ocaml-dev,
  libsqlite3-ocaml-dev,
  libzip-ocaml-dev,
  libocamlgraph-ocaml-dev,
  coq, libcoq-ocaml-dev
Build-Depends-Indep:
  rubber, hevea, lmodern,
  texlive-latex-recommended, texlive-latex-extra,
  texlive-fonts-recommended
Standards-Version: 3.9.8
Homepage: http://why3.lri.fr/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why3.git
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why3.git

Package: why3
Architecture: any
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
Recommends: alt-ergo | cvc3 | why3-coq | spass | z3
Suggests: why3-examples
Description: Software verification platform
 Why3 is a platform for deductive program verification. It provides a
 rich language for specification and programming, called WhyML, and
 relies on external theorem provers, both automated and interactive,
 to discharge verification conditions. Why3 comes with a standard
 library of logical theories (integer and real arithmetic, Boolean
 operations, sets and maps, etc.) and basic programming data
 structures (arrays, queues, hash tables, etc.). A user can write
 WhyML programs directly and get correct-by-construction OCaml
 programs through an automated extraction mechanism. WhyML is also
 used as an intermediate language for the verification of C, Java, or
 Ada programs.
 .
 Why3 is a complete reimplementation of the former Why platform. Among
 the new features are: numerous extensions to the input language, a
 new architecture for calling external provers, and a well-designed
 API, allowing to use Why3 as a software library. An important
 emphasis is put on modularity and genericity, giving the end user a
 possibility to easily reuse Why3 formalizations or to add support for
 a new external prover if wanted.

Package: why3-coq
Architecture: any
Depends: coq, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: why3
Description: Coq support for the why3 verification platform
 This package contains the compiled coq files that are necessary to
 use the coq proof assistant together with the why3 deductive
 verification platform, as well as the why3 tactic for coq.

Package: libwhy3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Section: ocaml
Description: ocaml librariries for why3 (dev)
 This package contains the libraries of the why3 verification platform
 for developing applications using why3.

Package: why3-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: why3
Description: Examples for the why3 verification platform
 This package contains examples, both of program verification tasks
 and pure logical verification tasks, for the why3 software verification
 platform.

Package: why3-doc-html
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: HTML Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in HTML format.

Package: why3-doc-pdf
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: PDF Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in PDF format.

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR=debian/tmp

%:
	dh $@ --with ocaml

override_dh_auto_configure configure-stamp:
	# necessary as long as we patch configure.in
	autoconf
	# EMACS=no disables compilation of elisp code
	# USEOCAMLFIND=no implies that libs are installed into /usr/lib/
	# instead of /usr/local/lib as indicated by ocamlfind (in case it
	# is installed)
	EMACS=no USEOCAMLFIND=no dh_auto_configure
	touch configure-stamp

override_dh_auto_build:

build-arch build-stamp: configure-stamp
	dh_testdir
	$(MAKE) all byte
	touch build-stamp

build-indep: configure-stamp
	dh_testdir
	$(MAKE) doc

override_dh_auto_install:
	# do nothing

override_dh_install-arch: build-stamp
	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
	# extra license file
	rm -f $(BUILDDIR)/usr/share/why3/LICENSE
	dh_install -a

override_dh_install-indep:
	# do nothing

override_dh_compress:
	dh_compress -Xmanual.pdf

override_dh_ocaml:
	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \
		--nodefined-map=why3:Graph

=== debian/tests/control ===
Tests: why3+alt-ergo
Depends: why3, alt-ergo

Tests: why3+cvc3
Depends: why3, cvc3

Tests: why3+spass
Depends:why3, spass

Tests: why3+z3
Depends:why3, z3

## why3 0.87.2

=== examples/gcd/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=gcd__EuclideanAlgorithm31
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../gcd.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../gcd.mlw
	$(WHY3) extract -D ocaml32 $< -o .

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f gcd__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml -pretty -noinline $(JSMAIN).byte


$(JSMAIN).byte: $(ML) jsmain.ml
	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== debian/changelog ===
why3 (0.87.2-3) unstable; urgency=medium

  * adapt to coq version 8.6:
    - patch coq8.6: compile coq plugin with coq8.6. Thanks to Guillaume
      Melquiond for the patch!
    - add autoconf to build-dependency (needed since configure.in is patched)
    - fix path of ocaml libdir in debian/libwhy3-ocaml-dev.install
 
 -- Ralf Treinen <treinen@debian.org>  Tue, 03 Jan 2017 20:56:05 +0100

why3 (0.87.2-2) sid; urgency=medium

  * install why3lang.sty:
    - add to why3.install
    - add target directory to why3.dirs
    - invoke dh --with tex
    - add build-dependency on tex-common

 -- Ralf Treinen <treinen@debian.org>  Wed, 21 Sep 2016 21:15:04 +0200

why3 (0.87.2-1) unstable; urgency=medium

  * new upstream release.
    - d/rules: replace EMACS=no by --disable-emacs-compilation
    - drop patch typos, applied by upstream
    - drop patch drop-timestamp, applied by upstream. As a consequence,
      we drop autoconf from d/rules and from build-dependencies 
  * add debian/tests/why3+coq

 -- Ralf Treinen <treinen@debian.org>  Thu, 01 Sep 2016 19:21:22 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  autoconf, 
-# autoconf only as long as we patch configure.in
+  autoconf,
   debhelper (>= 9), dh-ocaml,
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
@@ -14,7 +13,8 @@
   libsqlite3-ocaml-dev,
   libzip-ocaml-dev,
   libocamlgraph-ocaml-dev,
-  coq, libcoq-ocaml-dev
+  coq, libcoq-ocaml-dev,
+  tex-common
 Build-Depends-Indep:
   rubber, hevea, lmodern,
   texlive-latex-recommended, texlive-latex-extra,

## why3 0.87.3

=== debian/changelog ===
why3 (0.87.3-2) unstable; urgency=medium

  * upload to unstable
  * as-installed test why3+z3: do not fail when z3 segfaults.

 -- Ralf Treinen <treinen@debian.org>  Sat, 21 Jan 2017 21:02:08 +0100

why3 (0.87.3-1) experimental; urgency=medium

  * New upstream version:
    - drop patch coq8.6 which is now integrated by upstream.
  * Fix path of ocaml libdir in debian/libwhy3-ocaml-dev.install
  * Capitalization in short description of libwhy3-ocaml-dev
  * Drop build-dependency on autoconf

 -- Ralf Treinen <treinen@debian.org>  Thu, 12 Jan 2017 16:56:47 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  autoconf,
   debhelper (>= 9), dh-ocaml,
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
@@ -67,7 +66,7 @@
 Depends: ${misc:Depends}, ${ocaml:Depends}
 Provides: ${ocaml:Provides}
 Section: ocaml
-Description: ocaml librariries for why3 (dev)
+Description: OCaml librariries for why3 (dev)
  This package contains the libraries of the why3 verification platform
  for developing applications using why3.

=== debian/rules ===
--- 
+++ 
@@ -3,16 +3,13 @@
 BUILDDIR=debian/tmp
 
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml,tex
 
 override_dh_auto_configure configure-stamp:
-	# necessary as long as we patch configure.in
-	autoconf
-	# EMACS=no disables compilation of elisp code
 	# USEOCAMLFIND=no implies that libs are installed into /usr/lib/
 	# instead of /usr/local/lib as indicated by ocamlfind (in case it
 	# is installed)
-	EMACS=no USEOCAMLFIND=no dh_auto_configure
+	USEOCAMLFIND=no dh_auto_configure -- --disable-emacs-compilation
 	touch configure-stamp
 
 override_dh_auto_build:

=== debian/tests/control ===
--- 
+++ 
@@ -9,3 +9,6 @@
 
 Tests: why3+z3
 Depends:why3, z3
+
+Tests: why3+coq
+Depends: why3, why3-coq, coq

## why3 0.88.2

=== examples/defunctionalization/Makefile ===


BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


MAIN = main
OBJ = defunctionalization__Expr \
	defunctionalization__DirectSem \
	defunctionalization__CPS \
	defunctionalization__Defunctionalization \

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(ML)

doc:
	$(WHY3) doc ../defunctionalization.mlw
	$(WHY3) session html ../defunctionalization.mlw
	@echo firefox ../defunctionalization.html why3session.html

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../defunctionalization.mlw
	$(WHY3) extract -D ocaml64 ../defunctionalization.mlw -o .

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -g -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -g -c $<

clean::
	rm -f $(ML) *.cm[xio] $(MAIN).opt

=== debian/changelog ===
why3 (0.88.2-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el/s390x, as it hangs indefinately.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Dec 2017 08:40:43 +0100

why3 (0.88.2-1) unstable; urgency=medium

  * New upstream version.
  * Standards-Version 4.1.2 (no change)
  * d/rules:
    - recreate in target configure the empty directories that are
      in the orig tarball.
    - invoke dh_missing with --fail-missing
  * fix why3.install, add missing files from usr/lib
  * Added build-dep-indep texlive-bibtex-extra
  * debhelper compat level 10
  * New SMT solver cvc4:
    - add as an alternative Recommends
    - add autopkgtest test case

 -- Ralf Treinen <treinen@debian.org>  Tue, 12 Dec 2017 22:22:24 +0100

why3 (0.87.3-2ubuntu4) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:41:58 +0200

why3 (0.87.3-2ubuntu3) artful; urgency=medium

  * Don't run why3+z3 on s390x, fails. Already ignored on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Sep 2017 22:11:33 +0200

why3 (0.87.3-2ubuntu2) artful; urgency=medium

  * No-change rebuild for new menhir.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 29 Aug 2017 18:39:07 -0500

why3 (0.87.3-2ubuntu1) artful; urgency=medium

  * Skip why3+z3 test on ppc64el, as it hangs indefinately.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 17 Jul 2017 10:25:38 +0100

why3 (0.87.3-2build5) artful; urgency=high

  * No change rebuild against coq abi change.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 16 Jul 2017 23:46:41 +0100

why3 (0.87.3-2build4) artful; urgency=high

  * No change rebuild against ocaml with old binutils on arm64.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 16 Jul 2017 15:32:00 +0100

why3 (0.87.3-2build3) artful; urgency=medium

  * Rebuild due to changed ocaml abis.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 10 Jul 2017 18:00:11 +0100

why3 (0.87.3-2build2) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 01:29:49 +0100

why3 (0.87.3-2build1) artful; urgency=medium

  * No-change rebuild against libmenhir-ocaml-dev-gvxl7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 25 Jun 2017 08:11:24 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: why3
 Section: math
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper (>= 9), dh-ocaml,
+  debhelper (>= 10), dh-ocaml,
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
   libzarith-ocaml-dev,
@@ -17,8 +18,9 @@
 Build-Depends-Indep:
   rubber, hevea, lmodern,
   texlive-latex-recommended, texlive-latex-extra,
-  texlive-fonts-recommended
-Standards-Version: 3.9.8
+  texlive-fonts-recommended,
+  texlive-bibtex-extra
+Standards-Version: 4.1.2
 Homepage: http://why3.lri.fr/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why3.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why3.git
@@ -29,7 +31,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: alt-ergo | cvc3 | why3-coq | spass | z3
+Recommends: alt-ergo | cvc3 | cvc4 | why3-coq | spass | z3
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

=== debian/rules ===
--- 
+++ 
@@ -6,17 +6,16 @@
 	dh $@ --with ocaml,tex
 
 override_dh_auto_configure configure-stamp:
-	# USEOCAMLFIND=no implies that libs are installed into /usr/lib/
-	# instead of /usr/local/lib as indicated by ocamlfind (in case it
-	# is installed)
-	USEOCAMLFIND=no dh_auto_configure -- --disable-emacs-compilation
+	# empty dirs in the orig tarball which may be dropped by git
+	mkdir -p bin lib/plugins plugins/printer
+	dh_auto_configure -- --disable-emacs-compilation
 	touch configure-stamp
 
 override_dh_auto_build:
 
 build-arch build-stamp: configure-stamp
 	dh_testdir
-	$(MAKE) all byte
+	$(MAKE)
 	touch build-stamp
 
 build-indep: configure-stamp
@@ -35,6 +34,9 @@
 override_dh_install-indep:
 	# do nothing
 
+override_dh_missing:
+	dh_missing --fail-missing
+
 override_dh_compress:
 	dh_compress -Xmanual.pdf

## why3 0.88.3

=== examples/euler001/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=euler001__Euler001

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../euler001.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../euler001.mlw
	$(WHY3) extract -D ocaml32 ../euler001.mlw -o .

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* euler001__*.ml* int__*.ml*

=== examples/sudoku/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN = map__Map sudoku__Grid sudoku__TheClassicalSudokuGrid sudoku__Solver
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(GENML)

doc:
	$(WHY3) doc ../sudoku.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../sudoku.mlw
	$(WHY3) extract -D ocaml32 ../sudoku.mlw -o .

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml +nat.js $(JSMAIN).byte

$(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^

%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.annot *.o *.cm[xio] $(MAIN).opt $(MAIN).byte
	rm -f sudoku__*.ml why3__*.ml
	rm -f int__Int.ml map__Map.ml array__Array.ml

=== examples/vstte10_max_sum/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=vstte10_max_sum__MaxAndSum2 vstte10_max_sum__TestCase

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../vstte10_max_sum.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../vstte10_max_sum.mlw
	$(WHY3) extract -D ocaml32 ../vstte10_max_sum.mlw -o .

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* vstte10_max_sum__*.ml* int__*.ml*

=== examples/vstte12_combinators/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=vstte12_combinators__Combinators
OBJ=$(GEN) parse

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../vstte12_combinators.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../vstte12_combinators.mlw
	$(WHY3) extract -D ocaml32 ../vstte12_combinators.mlw -o .

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f vstte12_combinators__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml -pretty -noinline +nat.js $(JSMAIN).byte


$(JSMAIN).byte: $(CMO) jsmain.ml
#	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== debian/changelog ===
why3 (0.88.3-1ubuntu4) bionic; urgency=medium

  * Implement proper per-architecture handling of the why3+cvc4 autopkgtest.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Apr 2018 18:32:36 -0700

why3 (0.88.3-1ubuntu3) bionic; urgency=medium

  * debian/patches/portable-getopt.patch: fix unportable assumptions in
    getopt_long() handling.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Apr 2018 18:25:53 -0700

why3 (0.88.3-1ubuntu2) bionic; urgency=medium

  * Drop the why3+cvc4 test, since cvc4 is only available on x86 and
    there's no way to make autopkgtests per-architecture.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 22 Mar 2018 23:21:56 -0700

why3 (0.88.3-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el/s390x, as it hangs indefinitely.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jan 2018 10:46:52 +0100

why3 (0.88.3-1) unstable; urgency=medium

  * New upstream version.
    - drop creation of empty directories in debian/rules, this has been
      fixed by upstream.
  * Standards-Version 4.1.3 (no change)
  * debian/rules:
    - fix configure stamps
    - drop build stamps, we do not need them. 
    - dh-install: exclude extra LICENSE file
    - drop override_dh_auto_build 
  * debhelper compatibility level 11

 -- Ralf Treinen <treinen@debian.org>  Sun, 14 Jan 2018 14:52:54 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper (>= 10), dh-ocaml,
+  debhelper (>= 11), dh-ocaml,
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
   libzarith-ocaml-dev,
@@ -20,7 +20,7 @@
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra
-Standards-Version: 4.1.2
+Standards-Version: 4.1.3
 Homepage: http://why3.lri.fr/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why3.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why3.git

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR=debian/tmp

%:
	dh $@ --with ocaml,tex

override_dh_auto_configure: configure-stamp

configure-stamp:
	dh_auto_configure -- --disable-emacs-compilation
	touch configure-stamp

build-arch: configure-stamp
	dh_testdir
	$(MAKE)

build-indep: configure-stamp
	dh_testdir
	$(MAKE) doc

override_dh_auto_install:
	# do nothing

override_dh_install-arch: build-arch
	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
	dh_install -a -XLICENSE

override_dh_install-indep:
	# do nothing

override_dh_missing:
	dh_missing --fail-missing

override_dh_compress:
	dh_compress -Xmanual.pdf

override_dh_ocaml:
	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \
		--nodefined-map=why3:Graph

=== debian/tests/control ===
--- 
+++ 
@@ -3,6 +3,9 @@
 
 Tests: why3+cvc3
 Depends: why3, cvc3
+
+Tests: why3+cvc4
+Depends: why3, cvc4 [amd64 i386]
 
 Tests: why3+spass
 Depends:why3, spass

## why3 1.0.0

=== examples/multiprecision/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

all: why3 extract

clean:
	rm -rf build

why3:
	make -C ../..

dir:
	mkdir -p build

cfiles: why3 dir
	$(WHY3) extract -D c -L . --recursive --modular --interface -o build/ wmpn.mlw

extract: why3 dir cfiles

CFILES = build/uint64gmp.c build/div.c build/logical.c build/mul.c build/sub.c build/add.c build/compare.c build/util.c  build/int32.c

tests: extract check-gmp
	gcc -O2 -Wall -Wno-unused-function -g -std=gnu99 tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o build/tests
	gcc -O2 -Wall -Wno-unused-function -g -std=gnu99 -DCOMPARE_MINI tests.c $(CFILES) -I$(GMP_DIR) -Irandom -Imini-gmp -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o build/minitests
	./build/tests
	./build/minitests

bench-tests: extract
	gcc -O2 -Wall -g -std=gnu99 tests.c $(CFILES) -Ibench-include -Irandom -fomit-frame-pointer -fno-tree-vectorize -lgmp -o build/bench-tests


build/why3%bench: extract check-gmp
	gcc -O3 -Wall -g -std=gnu99 -DTEST_WHY3 -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

build/gmp%bench: extract check-gmp
	gcc -O3 -Wall -g -std=gnu99 -DTEST_GMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

build/minigmp%bench: extract
	gcc -O3 -Wall -g -std=gnu99 -DTEST_MINIGMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o $@

alltests: tests build/why3addbench build/why3mulbench build/why3divbench build/gmpaddbench build/gmpmulbench build/gmpdivbench build/minigmpaddbench build/minigmpmulbench build/minigmpdivbench

data: alltests
	mkdir -p bench
	./build/why3addbench > bench/why3add
	./build/why3mulbench > bench/why3mul
	./build/why3divbench > bench/why3div
	./build/gmpaddbench > bench/gmpadd
	./build/gmpmulbench > bench/gmpmul
	./build/gmpdivbench > bench/gmpdiv
	./build/minigmpaddbench > bench/minigmpadd
	./build/minigmpmulbench > bench/minigmpmul
	./build/minigmpdivbench > bench/minigmpdiv

plots: data
	make all -C plots

check-gmp:
ifndef GMP_DIR
	$(error GMP_DIR is undefined)
endif
ifndef GMP_LIB
	$(error GMP_LIB is undefined)
endif

=== debian/changelog ===
why3 (1.0.0-2.1~build1) cosmic; urgency=medium

  * Make it syncable again

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 17 Aug 2018 10:01:00 +0200

why3 (1.0.0-2) unstable; urgency=medium

  * as-installed test why3+cvc4:
    - dropped erroneous version constraint on cvc4.
    - invoke prover simply as CVC4
    - marked test as skip-not-installable, instead of flaky, as cvc4 does not
      build on all architectures (architecture restriction set in src:cvc4),
      and since cvc4 is only an alternative dependency of why3.
  * as-installed test why3+cvc3:
    - marked test as skip-not-installable, instead of flaky, since cvc3
      recently has FTBFS, and since cvc3 is only an alternative dependency
      of why3.
  * as-installed-test why3+spass:
    - marked test as skip-not-installable since spass recently has FTBFS
      issues and was dropped from testing, and since spass is only an
      alternative dependency of why3.

 -- Ralf Treinen <treinen@debian.org>  Sun, 12 Aug 2018 23:29:44 +0200

why3 (1.0.0-1) unstable; urgency=medium

  * New upstream version
    - drop patch getopt_long-return-value which has been applied upstream
  * Upstream does no longer build coq-tactic:
    - drop these from why3-coq.install
    - drop mention of these from the long description of why3-coq
  * libwhy3-ocaml-dep: add dependency ${shlibs:Depends}
  * As-installed-tests:
    - adapt the why3 files in d/tests/why to the new syntax of WhyML
    - mark tests with cvc3 and cvc4 as flaky  (closes: #902308)
    - test why3+cvc4: specify 'CVC4 1.5' in the invocation of why3,
      constrain the dependency of the test on cvc4 accordingly.
  * NEWS.Debian: new syntax of WhyML, new location of standard lib

 -- Ralf Treinen <treinen@debian.org>  Wed, 27 Jun 2018 22:19:33 +0200

why3 (0.88.3-3) unstable; urgency=medium

  * d/control: update Vcs-* fields to salsa
  * Add build-dependendency texlive-plain-generic to fix FTBFS with
    texlive 2018.20180505-1 (closes: #899084)
  * test why3+cvc4: skip when cvc4 is not available (closes: #895104)

 -- Ralf Treinen <treinen@debian.org>  Sun, 27 May 2018 13:37:54 +0200

why3 (0.88.3-2) unstable; urgency=medium

  * Standards-version 4.1.4 (no change).
  * d/copyright: https in format specification
  * Add patch getopt_long-return-value which fixes a portability issue
    (closes: #895103). Thanks a lot to Steve Langasek for the patch!

 -- Ralf Treinen <treinen@debian.org>  Sat, 07 Apr 2018 11:54:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: why3
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper (>= 11), dh-ocaml,
@@ -17,13 +16,14 @@
   tex-common
 Build-Depends-Indep:
   rubber, hevea, lmodern,
+  texlive-plain-generic,
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://why3.lri.fr/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why3.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why3.git
+Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/why3
 
 Package: why3
 Architecture: any
@@ -61,11 +61,11 @@
 Description: Coq support for the why3 verification platform
  This package contains the compiled coq files that are necessary to
  use the coq proof assistant together with the why3 deductive
- verification platform, as well as the why3 tactic for coq.
+ verification platform.
 
 Package: libwhy3-ocaml-dev
 Architecture: any
-Depends: ${misc:Depends}, ${ocaml:Depends}
+Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
 Section: ocaml
 Description: OCaml librariries for why3 (dev)

=== debian/tests/control ===
--- 
+++ 
@@ -3,12 +3,15 @@
 
 Tests: why3+cvc3
 Depends: why3, cvc3
+Restrictions: skip-not-installable
 
 Tests: why3+cvc4
-Depends: why3, cvc4 [amd64 i386]
+Depends: why3, cvc4
+Restrictions: skip-not-installable
 
 Tests: why3+spass
 Depends:why3, spass
+Restrictions: skip-not-installable
 
 Tests: why3+z3
 Depends:why3, z3

## why3 1.1.0

=== examples/multiprecision/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

all: why3 extract

clean:
	rm -rf build

why3:
	make -C ../..

dir:
	mkdir -p build

cfiles: why3 dir
	$(WHY3) extract -D c -L . --recursive --modular --interface -o build/ wmpn.mlw

extract: why3 dir cfiles

CFILES = build/uint64gmp.c build/toom.c build/div.c build/logical.c build/mul.c build/sub.c build/add.c build/compare.c build/util.c build/int32.c

tests: extract check-gmp
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -pedantic tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o build/tests
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -pedantic -DCOMPARE_MINI tests.c $(CFILES) -I$(GMP_DIR) -Irandom -Imini-gmp -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o build/minitests
	./build/tests
	./build/minitests

bench-tests: extract
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 tests.c $(CFILES) -Ibench-include -Irandom -fomit-frame-pointer -fno-tree-vectorize -lgmp -o build/bench-tests


build/why3%bench: extract check-gmp
	gcc -O3 -Wall -g -std=c11 -DTEST_WHY3 -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

build/gmp%bench: extract check-gmp
	gcc -O3 -Wall -g -std=c11 -DTEST_GMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

#build/minigmp%bench: extract
#	gcc -O3 -Wall -g -std=c11 -DTEST_MINIGMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Irandom -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o $@

alltests: tests build/why3addbench build/why3mulbench build/why3toombench build/why3divbench build/gmpaddbench build/gmpmulbench build/gmptoombench build/gmpdivbench #build/minigmpaddbench build/minigmpmulbench build/minigmpdivbench

data: alltests
	mkdir -p bench
	./build/why3addbench > bench/why3add
	./build/why3mulbench > bench/why3mul
	./build/why3toombench > bench/why3toom
	./build/why3divbench > bench/why3div
	./build/gmpaddbench > bench/gmpadd
	./build/gmpmulbench > bench/gmpmul
	./build/gmptoombench > bench/gmptoom
	./build/gmpdivbench > bench/gmpdiv
#	./build/minigmpaddbench > bench/minigmpadd
#	./build/minigmpmulbench > bench/minigmpmul
#	./build/minigmpdivbench > bench/minigmpdiv

plots: data
	make all -C plots

check-gmp:
ifndef GMP_DIR
	$(error GMP_DIR is undefined)
endif
ifndef GMP_LIB
	$(error GMP_LIB is undefined)
endif

=== examples/multiprecision/plots/Makefile ===
all:
	./divplot &
	./divrelative &
	./mulrelative &
	./addrelative &
	./addplot &
#	./minidivrelative &
#	./minimulrelative &
#	./miniaddrelative &
#	./gmpdivplot &
#	./gmpmulplot &
#	./gmpaddplot &
	./toomrelative

=== debian/changelog ===
why3 (1.1.0-1build1) disco; urgency=medium

  * No-change rebuild against latest menhir

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 25 Nov 2018 10:27:42 -0500

why3 (1.1.0-1) unstable; urgency=medium

  * New upstream version. Works with cvc4 version 1.6 (closes: #906001)
  * Since lablgtk2 does no longer build liblablgtksourceview2-ocaml-dev:
    - drop build-dependencies liblablgtk2-ocaml-dev and
      liblablgtksourceview2-ocaml-dev
    - d/rules: configure with --disable-ide
    - note in NEWS that the IDE is dropped.
    - drop mention of IDE from why3.1 manpage.
  * Dependencies on provers : enforce version >= 2.0.0. for alt-ergo since
    upstream has dropped support for older versions. Add an
    "skip-not-installable" on the test why3+alt-ergo
  * Test why3+cvc4: fix selection of solver cvc4
  * d/copyright: update full text of CC license.
  * d/rules: remove empty why3shapes.gz files
  * Standards-Version 4.2.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Mon, 05 Nov 2018 19:23:56 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,6 @@
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
   libzarith-ocaml-dev,
-  liblablgtk2-ocaml-dev, liblablgtksourceview2-ocaml-dev,
   libsqlite3-ocaml-dev,
   libzip-ocaml-dev,
   libocamlgraph-ocaml-dev,
@@ -20,7 +19,7 @@
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/why3
@@ -31,7 +30,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: alt-ergo | cvc3 | cvc4 | why3-coq | spass | z3
+Recommends:  cvc3 | cvc4 | why3-coq | spass | z3 | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

## why3 1.1.1

=== debian/changelog ===
why3 (1.1.1-3) unstable; urgency=medium

  * disable coq support.

 -- Ralf Treinen <treinen@debian.org>  Sun, 03 Feb 2019 23:01:38 +0100

why3 (1.1.1-2) unstable; urgency=medium

  * why3-coq: depend on the virtual package provided by coq and indicating
    the version of the coq ABI (closes: #918633).
  * Standards-Version 4.3.0 (no change)
  * Debhelper compatibility level 12
    - override dh_dwz to use --no-dwz-multifile

 -- Ralf Treinen <treinen@debian.org>  Thu, 10 Jan 2019 20:12:24 +0100

why3 (1.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Fix whitespace in debian/{control/changelog}

 -- Ralf Treinen <treinen@debian.org>  Tue, 18 Dec 2018 04:50:38 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper (>= 11), dh-ocaml,
+  debhelper (>= 12), dh-ocaml,
   ocaml-nox (>= 3.11.2),
   menhir, libmenhir-ocaml-dev,
   libzarith-ocaml-dev,
   libsqlite3-ocaml-dev,
   libzip-ocaml-dev,
   libocamlgraph-ocaml-dev,
-  coq, libcoq-ocaml-dev,
+# coq, libcoq-ocaml-dev,
   tex-common
 Build-Depends-Indep:
   rubber, hevea, lmodern,
@@ -19,7 +19,7 @@
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/why3
@@ -30,7 +30,8 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends:  cvc3 | cvc4 | why3-coq | spass | z3 | alt-ergo (>= 2.0.0)
+# Recommends: cvc3 | cvc4 | why3-coq | spass | z3 | alt-ergo (>= 2.0.0)
+Recommends: cvc3 | cvc4 | spass | z3 | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a
@@ -55,7 +56,8 @@
 
 Package: why3-coq
 Architecture: any
-Depends: coq, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
+# Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Recommends: why3
 Description: Coq support for the why3 verification platform
  This package contains the compiled coq files that are necessary to

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 BUILDDIR=debian/tmp
+# include /usr/share/coq/coqvars.mk
 
 %:
 	dh $@ --with ocaml,tex
@@ -8,7 +9,10 @@
 override_dh_auto_configure: configure-stamp
 
 configure-stamp:
-	dh_auto_configure -- --disable-emacs-compilation
+	dh_auto_configure -- \
+		--disable-emacs-compilation \
+		--disable-ide \
+		--disable-coq-libs
 	touch configure-stamp
 
 build-arch: configure-stamp
@@ -25,6 +29,16 @@
 override_dh_install-arch: build-arch
 	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
 	dh_install -a -XLICENSE
+	# echo 'F:CoqABI=$(COQ_ABI)' >> debian/why3-coq.substvars
+
+override_dh_installexamples:
+	dh_installexamples
+	if [ -d debian/why3-examples/usr/share/doc/why3-examples/examples ]; \
+	then \
+	  find debian/why3-examples/usr/share/doc/why3-examples/examples \
+	    -name why3shapes.gz \
+	    -exec sh -c 'if [ $$(zcat {} | wc -c) -eq 0 ]; then \rm {}; fi' \;;\
+	fi
 
 override_dh_install-indep:
 	# do nothing
@@ -38,3 +52,5 @@
 override_dh_ocaml:
 	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \
 		--nodefined-map=why3:Graph
+override_dh_dwz:
+	dh_dwz --no-dwz-multifile

=== debian/tests/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Tests: why3+alt-ergo
-Depends: why3, alt-ergo
+Depends: why3, alt-ergo (>= 2.0.0)
+Restrictions: skip-not-installable
 
 Tests: why3+cvc3
 Depends: why3, cvc3
@@ -16,5 +17,5 @@
 Tests: why3+z3
 Depends:why3, z3
 
-Tests: why3+coq
-Depends: why3, why3-coq, coq
+# Tests: why3+coq
+# Depends: why3, why3-coq, coq
